import{s as Xe,n as Ye,o as Ze}from"../chunks/scheduler.7bc62968.js";import{S as et,i as tt,g as s,s as a,r as d,A as it,h as o,f as i,c as l,j as Qe,u as m,x as r,k as He,y as nt,a as n,v as h,d as u,t as p,w as f}from"../chunks/index.2f8492b0.js";import{H as w,E as at}from"../chunks/EditOnGithub.2a9ce03a.js";function lt(Me){let c,J,V,Q,v,X,b,Pe='We are going to learn about Knowledge Distillation, the method behind <a href="https://huggingface.co/distilgpt2" rel="nofollow">distilGPT</a> and <a href="https://huggingface.co/distilbert-base-uncased-finetuned-sst-2-english" rel="nofollow">distilbert</a>, two of <em>the most downloaded models on the Hugging Face Hub!</em>',Y,y,De='Presumably, we’ve all had teachers who “teach” by simply providing us the correct answers and then testing us on questions we haven’t seen before, analogous to supervised learning of machine learning models where we provide a labeled dataset to train on. Instead of having a model train on labels, however, we can pursue <a href="https://arxiv.org/abs/1503.02531" rel="nofollow">Knowledge Distillation</a> as an alternative to arriving at a much smaller model that can perform comparably to the larger model and much faster to boot.',Z,$,ee,T,Ke="Imagine you were given this multiple-choice question:",te,x,Ie='<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/multiple-choice-question.png" alt="Multiple Choice Question"/>',ie,k,qe="If you had someone just tell you, “The answer is Draco Malfoy,” that doesn’t teach you a whole lot about each of the characters’ relative relationships with Harry Potter.",ne,C,Ae="On the other hand, if someone tells you, “I am very confident it is not Ron Weasley, I am somewhat confident it is not Neville Longbottom, and I am very confident that it <em>is</em> Draco Malfoy,” this gives you some information about these characters’ relationships to Harry Potter! This is precisely the kind of information that gets passed down to our student model under the Knowledge Distillation paradigm.",ae,L,le,_,Ee='In the paper <a href="https://arxiv.org/abs/1503.02531" rel="nofollow"><em>Distilling the Knowledge in a Neural Network</em></a>, Hinton et al. introduced the training methodology known as knowledge distillation, taking inspiration from <em>insects</em>, of all things. Just as insects transition from larval to adult forms that are optimized for different tasks, large-scale machine learning models can initially be cumbersome, like larvae, for extracting structure from data but can distill their knowledge into smaller, more efficient models for deployment.',se,H,ze="The essence of Knowledge Distillation is using the predicted logits from a teacher network to pass information to a smaller, more efficient student model. We do this by re-writing the loss function to contain a <em>distillation loss</em>, which encourages the student model’s distribution over the output space to approximate the teacher’s.",oe,M,Ne="The distillation loss is formulated as:",re,P,je='<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/KL-Loss.png" alt="Distillation Loss"/>',de,D,Ue='The KL loss refers to the <a href="https://en.wikipedia.org/wiki/Kullback%E2%80%93Leibler_divergence" rel="nofollow">Kullback-Leibler Divergence</a> between the teacher and the student’s output distributions. The overall loss for the student model is then formulated as the sum of this distillation loss with the standard cross-entropy loss over the ground-truth labels.',me,K,Be='To see this loss function implemented in Python and a fully worked out example in Python, let’s check out the <a href="https://github.com/johko/computer-vision-course/blob/main/notebooks/Unit%203%20-%20Vision%20Transformers/KnowledgeDistillation.ipynb" rel="nofollow">notebook for this section</a>.',he,g,Ge='<img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/>',ue,I,pe,q,We="Knowledge distillation has become increasingly crucial as AI models are deployed on edge devices. Deploying a large-scale model, such as one with a 1 GB size and a latency of 1 second, is impractical for real-time applications due to high computational and memory requirements. These limitations are primarily attributed to the model’s size. As a result, the field has embraced knowledge distillation, a technique that reduces model parameters by over 90% with minimal performance degradation.",fe,A,ce,E,ge,z,Fe="In the context of information theory, entropy is analogous to its counterpart in physics, where it measures the “chaos” or disorder within a system. In our scenario, it quantifies the amount of information a distribution contains. Consider the following example:",we,N,Oe="<li>Which is harder to remember: <code>[0, 1, 0, 0]</code> or <code>[0.2, 0.5, 0.2, 0.1]</code>?</li>",ve,j,Se=`The first vector, <code>[0, 1, 0, 0]</code>, is easier to remember and compress, as it contains less information. This can be represented as “1” in the second position. On the other hand, <code>[0.2, 0.5, 0.2, 0.1]</code> contains more information.
Building on that, let’s say, for example, we trained an 80M parameter network on ImageNet and then distilled it (as discussed earlier) into a 5M parameter student model. We would find that the entropy contained in the output of the teacher model is much lower than that of the student model. This means that the output of the student model, even though correct, is more chaotic than the teacher’s outputs. This comes down to a simple fact: the teacher’s additional parameters help it discern between classes more easily as it extracts more features. This perspective on knowledge distillation is very interesting and is actively being researched to reduce the student’s entropy, either by using it as a loss function or by applying similar metrics inspired by physics (such as energy).`,be,U,ye,B,Ve="Models learn iteratively by minimizing a loss function and updating their parameters through gradient descent. Consider a set of parameters <code>P = {w1, w2, w3, ..., wn}</code>, whose role in the teacher model is to activate when detecting a sample of class A. If an ambiguous sample resembles class A but belongs to class B, the model’s gradient update will be aggressive after the misclassification, leading to instability. In contrast, the distillation process, with the teacher model’s soft targets, promotes more stable and coherent gradient updates during training, resulting in a smoother learning process for the student model.",$e,G,Te,W,Re="The presence of a teacher model allows the student model to train on unlabeled data. The teacher model can generate pseudo-labels for these unlabeled samples, which the student model can then use for training. This approach significantly increases the amount of usable training data.",xe,F,ke,O,Je="Deep learning models are typically trained with the assumption that providing enough data will allow them to approximate a function <code>F</code> that accurately represents the underlying phenomenon. However, in many cases, data scarcity makes this assumption unrealistic. The traditional approach involves building larger models and fine-tuning them iteratively to achieve optimal results. In contrast, knowledge distillation shifts this perspective: given that we already have a well-trained teacher model <code>F</code>, the goal becomes approximating <code>F</code> using a smaller model <code>f</code>.",Ce,S,Le,R,_e;return v=new w({props:{title:"Knowledge Distillation with Vision Transformers",local:"knowledge-distillation-with-vision-transformers",headingTag:"h1"}}),$=new w({props:{title:"Intuition Behind Knowledge Distillation",local:"intuition-behind-knowledge-distillation",headingTag:"h2"}}),L=new w({props:{title:"Distilling the Knowledge in a Neural Network",local:"distilling-the-knowledge-in-a-neural-network",headingTag:"h2"}}),I=new w({props:{title:"Leveraging Knowledge Distillation for Edge Devices",local:"leveraging-knowledge-distillation-for-edge-devices",headingTag:"h1"}}),A=new w({props:{title:"The Consequences(good & bad) of Knowledge Distillation",local:"the-consequencesgood--bad-of-knowledge-distillation",headingTag:"h2"}}),E=new w({props:{title:"1. Entropy Gain",local:"1-entropy-gain",headingTag:"h3"}}),U=new w({props:{title:"2. Coherent Gradient Updates",local:"2-coherent-gradient-updates",headingTag:"h3"}}),G=new w({props:{title:"3. Ability to Train on Unlabeled Data",local:"3-ability-to-train-on-unlabeled-data",headingTag:"h3"}}),F=new w({props:{title:"4. A Shift in Perspective",local:"4-a-shift-in-perspective",headingTag:"h3"}}),S=new at({props:{source:"https://github.com/huggingface/computer-vision-course/blob/main/chapters/en/unit3/vision-transformers/knowledge-distillation.mdx"}}),{c(){c=s("meta"),J=a(),V=s("p"),Q=a(),d(v.$$.fragment),X=a(),b=s("p"),b.innerHTML=Pe,Y=a(),y=s("p"),y.innerHTML=De,Z=a(),d($.$$.fragment),ee=a(),T=s("p"),T.textContent=Ke,te=a(),x=s("p"),x.innerHTML=Ie,ie=a(),k=s("p"),k.textContent=qe,ne=a(),C=s("p"),C.innerHTML=Ae,ae=a(),d(L.$$.fragment),le=a(),_=s("p"),_.innerHTML=Ee,se=a(),H=s("p"),H.innerHTML=ze,oe=a(),M=s("p"),M.textContent=Ne,re=a(),P=s("p"),P.innerHTML=je,de=a(),D=s("p"),D.innerHTML=Ue,me=a(),K=s("p"),K.innerHTML=Be,he=a(),g=s("a"),g.innerHTML=Ge,ue=a(),d(I.$$.fragment),pe=a(),q=s("p"),q.textContent=We,fe=a(),d(A.$$.fragment),ce=a(),d(E.$$.fragment),ge=a(),z=s("p"),z.textContent=Fe,we=a(),N=s("ul"),N.innerHTML=Oe,ve=a(),j=s("p"),j.innerHTML=Se,be=a(),d(U.$$.fragment),ye=a(),B=s("p"),B.innerHTML=Ve,$e=a(),d(G.$$.fragment),Te=a(),W=s("p"),W.textContent=Re,xe=a(),d(F.$$.fragment),ke=a(),O=s("p"),O.innerHTML=Je,Ce=a(),d(S.$$.fragment),Le=a(),R=s("p"),this.h()},l(e){const t=it("svelte-u9bgzb",document.head);c=o(t,"META",{name:!0,content:!0}),t.forEach(i),J=l(e),V=o(e,"P",{}),Qe(V).forEach(i),Q=l(e),m(v.$$.fragment,e),X=l(e),b=o(e,"P",{"data-svelte-h":!0}),r(b)!=="svelte-lyoktq"&&(b.innerHTML=Pe),Y=l(e),y=o(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-vq4gf6"&&(y.innerHTML=De),Z=l(e),m($.$$.fragment,e),ee=l(e),T=o(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-v5zyyx"&&(T.textContent=Ke),te=l(e),x=o(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-1vpf9y2"&&(x.innerHTML=Ie),ie=l(e),k=o(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-193lyi0"&&(k.textContent=qe),ne=l(e),C=o(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-1vb7llp"&&(C.innerHTML=Ae),ae=l(e),m(L.$$.fragment,e),le=l(e),_=o(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-iuhjk3"&&(_.innerHTML=Ee),se=l(e),H=o(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-mem9ra"&&(H.innerHTML=ze),oe=l(e),M=o(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-1l2wqyt"&&(M.textContent=Ne),re=l(e),P=o(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-y84sde"&&(P.innerHTML=je),de=l(e),D=o(e,"P",{"data-svelte-h":!0}),r(D)!=="svelte-1bp2ny7"&&(D.innerHTML=Ue),me=l(e),K=o(e,"P",{"data-svelte-h":!0}),r(K)!=="svelte-1onfg6s"&&(K.innerHTML=Be),he=l(e),g=o(e,"A",{target:!0,href:!0,"data-svelte-h":!0}),r(g)!=="svelte-rzabs7"&&(g.innerHTML=Ge),ue=l(e),m(I.$$.fragment,e),pe=l(e),q=o(e,"P",{"data-svelte-h":!0}),r(q)!=="svelte-8ynkco"&&(q.textContent=We),fe=l(e),m(A.$$.fragment,e),ce=l(e),m(E.$$.fragment,e),ge=l(e),z=o(e,"P",{"data-svelte-h":!0}),r(z)!=="svelte-sday1k"&&(z.textContent=Fe),we=l(e),N=o(e,"UL",{"data-svelte-h":!0}),r(N)!=="svelte-uyzjhv"&&(N.innerHTML=Oe),ve=l(e),j=o(e,"P",{"data-svelte-h":!0}),r(j)!=="svelte-4l4qx8"&&(j.innerHTML=Se),be=l(e),m(U.$$.fragment,e),ye=l(e),B=o(e,"P",{"data-svelte-h":!0}),r(B)!=="svelte-1evmqf3"&&(B.innerHTML=Ve),$e=l(e),m(G.$$.fragment,e),Te=l(e),W=o(e,"P",{"data-svelte-h":!0}),r(W)!=="svelte-vn6g4s"&&(W.textContent=Re),xe=l(e),m(F.$$.fragment,e),ke=l(e),O=o(e,"P",{"data-svelte-h":!0}),r(O)!=="svelte-1x06r33"&&(O.innerHTML=Je),Ce=l(e),m(S.$$.fragment,e),Le=l(e),R=o(e,"P",{}),Qe(R).forEach(i),this.h()},h(){He(c,"name","hf:doc:metadata"),He(c,"content",st),He(g,"target","_blank"),He(g,"href","https://colab.research.google.com/github/johko/computer-vision-course/blob/main/notebooks/Unit%203%20-%20Vision%20Transformers/KnowledgeDistillation.ipynb")},m(e,t){nt(document.head,c),n(e,J,t),n(e,V,t),n(e,Q,t),h(v,e,t),n(e,X,t),n(e,b,t),n(e,Y,t),n(e,y,t),n(e,Z,t),h($,e,t),n(e,ee,t),n(e,T,t),n(e,te,t),n(e,x,t),n(e,ie,t),n(e,k,t),n(e,ne,t),n(e,C,t),n(e,ae,t),h(L,e,t),n(e,le,t),n(e,_,t),n(e,se,t),n(e,H,t),n(e,oe,t),n(e,M,t),n(e,re,t),n(e,P,t),n(e,de,t),n(e,D,t),n(e,me,t),n(e,K,t),n(e,he,t),n(e,g,t),n(e,ue,t),h(I,e,t),n(e,pe,t),n(e,q,t),n(e,fe,t),h(A,e,t),n(e,ce,t),h(E,e,t),n(e,ge,t),n(e,z,t),n(e,we,t),n(e,N,t),n(e,ve,t),n(e,j,t),n(e,be,t),h(U,e,t),n(e,ye,t),n(e,B,t),n(e,$e,t),h(G,e,t),n(e,Te,t),n(e,W,t),n(e,xe,t),h(F,e,t),n(e,ke,t),n(e,O,t),n(e,Ce,t),h(S,e,t),n(e,Le,t),n(e,R,t),_e=!0},p:Ye,i(e){_e||(u(v.$$.fragment,e),u($.$$.fragment,e),u(L.$$.fragment,e),u(I.$$.fragment,e),u(A.$$.fragment,e),u(E.$$.fragment,e),u(U.$$.fragment,e),u(G.$$.fragment,e),u(F.$$.fragment,e),u(S.$$.fragment,e),_e=!0)},o(e){p(v.$$.fragment,e),p($.$$.fragment,e),p(L.$$.fragment,e),p(I.$$.fragment,e),p(A.$$.fragment,e),p(E.$$.fragment,e),p(U.$$.fragment,e),p(G.$$.fragment,e),p(F.$$.fragment,e),p(S.$$.fragment,e),_e=!1},d(e){e&&(i(J),i(V),i(Q),i(X),i(b),i(Y),i(y),i(Z),i(ee),i(T),i(te),i(x),i(ie),i(k),i(ne),i(C),i(ae),i(le),i(_),i(se),i(H),i(oe),i(M),i(re),i(P),i(de),i(D),i(me),i(K),i(he),i(g),i(ue),i(pe),i(q),i(fe),i(ce),i(ge),i(z),i(we),i(N),i(ve),i(j),i(be),i(ye),i(B),i($e),i(Te),i(W),i(xe),i(ke),i(O),i(Ce),i(Le),i(R)),i(c),f(v,e),f($,e),f(L,e),f(I,e),f(A,e),f(E,e),f(U,e),f(G,e),f(F,e),f(S,e)}}}const st='{"title":"Knowledge Distillation with Vision Transformers","local":"knowledge-distillation-with-vision-transformers","sections":[{"title":"Intuition Behind Knowledge Distillation","local":"intuition-behind-knowledge-distillation","sections":[],"depth":2},{"title":"Distilling the Knowledge in a Neural Network","local":"distilling-the-knowledge-in-a-neural-network","sections":[],"depth":2}],"depth":1}';function ot(Me){return Ze(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ht extends et{constructor(c){super(),tt(this,c,ot,lt,Xe,{})}}export{ht as component};
