import{s as ie,n as ne,o as ae}from"../chunks/scheduler.7bc62968.js";import{S as le,i as oe,g as o,s as a,r as P,A as se,h as s,f as i,c as l,j as ee,u as L,x,k as te,y as re,a as n,v as T,d as y,t as _,w as k}from"../chunks/index.2f8492b0.js";import{H as B,E as pe}from"../chunks/EditOnGithub.2a9ce03a.js";function me(W){let r,A,C,M,p,V,m,K=`So far we have learned about the fundamentals of multimodality with a special spotlight of Vision Language Models. This chapters provide a short overview of CLIP and similar models, highlighting their unique features and applicability to various machine learning tasks.
It sets the stage for a high-level exploration of key multimodal models that have emerged before and after CLIP, showcasing their significant contributions to the advancement of multimodal AI.`,G,u,N,d,U=`In this part, we explore the innovative attempts in multimodal AI before CLIP.
The focus is on influential papers that used deep learning to make significant strides in the field:`,S,g,J='<li><p><strong>“Multimodal Deep Learning” by Ngiam et al. (2011):</strong> This paper demonstrated the use of deep learning for multimodal inputs, emphasizing the potential of neural networks in integrating different data types. It laid the groundwork for future innovations in multimodal AI.</p> <ul><li><a href="https://people.csail.mit.edu/khosla/papers/icml2011_ngiam.pdf" rel="nofollow">Multimodal Deep Learning</a></li></ul></li> <li><p><strong>“Deep Visual-Semantic Alignments for Generating Image Descriptions” by Karpathy and Fei-Fei (2015):</strong> This study presented a method for aligning textual data with specific image regions, enhancing the interpretability of multimodal systems and advancing the understanding of complex visual-textual relationships.</p> <ul><li><a href="https://cs.stanford.edu/people/karpathy/cvpr2015.pdf" rel="nofollow">Deep Visual-Semantic Alignments for Generating Image Descriptions</a></li></ul></li> <li><p><strong>“Show and Tell: A Neural Image Caption Generator” by Vinyals et al. (2015):</strong> This paper marked a significant step in practical multimodal AI by showing how CNNs and RNNs could be combined to transform visual information into descriptive language.</p> <ul><li><a href="https://arxiv.org/abs/1411.4555" rel="nofollow">Show and Tell: A Neural Image Caption Generator</a></li></ul></li>',H,f,O,h,Q="The emergence of CLIP brought new dimensions to multimodal models, as illustrated by the following developments:",D,c,X='<li><p><strong>CLIP:</strong> OpenAI’s CLIP was a game-changer, learning from a vast array of internet text-image pairs and enabling zero-shot learning, contrasting with earlier models.</p> <ul><li><a href="https://openai.com/blog/clip/" rel="nofollow">CLIP</a></li></ul></li> <li><p><strong>GroupViT:</strong> Innovating in segmentation and semantic understanding, GroupViT combined these aspects with language, showing advanced integration of language and vision.</p> <ul><li><a href="https://arxiv.org/abs/2202.11094" rel="nofollow">GroupViT</a></li></ul></li> <li><p><strong>BLIP:</strong> BLIP introduced bidirectional learning between vision and language, pushing the boundaries for generating text from visual inputs.</p> <ul><li><a href="https://arxiv.org/abs/2201.12086" rel="nofollow">BLIP</a></li></ul></li> <li><p><strong>OWL-VIT:</strong> Focusing on object-centric representations, OWL-VIT advanced the understanding of objects within images in context with text.</p> <ul><li><a href="https://arxiv.org/abs/2205.06230" rel="nofollow">OWL-VIT</a></li></ul></li>',E,v,q,w,Y=`Hopefully, this section has provided a concise overview of pivotal works in multimodal AI before and after CLIP.
These developments highlight the evolving methods of processing multimodal data and their implications for AI applications.`,z,$,Z=`The upcoming sections will delve into the “Losses” aspect, focusing on various loss functions and self-supervised learning crucial for training multimodal models.
The “Models” section will provide a deeper understanding of CLIP and its variants, exploring their designs and functionalities.
Finally, the “Practical Notebooks” section will offer hands-on experience, addressing challenges like data bias and applying these models in tasks such as image search engines and visual question answering systems.
These sections aim to deepen your knowledge and practical skills in the multifaceted world of multimodal AI.`,F,b,R,I,j;return p=new B({props:{title:"CLIP and Relatives",local:"clip-and-relatives",headingTag:"h1"}}),u=new B({props:{title:"Pre-CLIP",local:"pre-clip",headingTag:"h2"}}),f=new B({props:{title:"Post-CLIP",local:"post-clip",headingTag:"h2"}}),v=new B({props:{title:"Conclusion",local:"conclusion",headingTag:"h2"}}),b=new pe({props:{source:"https://github.com/huggingface/computer-vision-course/blob/main/chapters/en/unit4/multimodal-models/clip-and-relatives/Introduction.mdx"}}),{c(){r=o("meta"),A=a(),C=o("p"),M=a(),P(p.$$.fragment),V=a(),m=o("p"),m.textContent=K,G=a(),P(u.$$.fragment),N=a(),d=o("p"),d.textContent=U,S=a(),g=o("ol"),g.innerHTML=J,H=a(),P(f.$$.fragment),O=a(),h=o("p"),h.textContent=Q,D=a(),c=o("ol"),c.innerHTML=X,E=a(),P(v.$$.fragment),q=a(),w=o("p"),w.textContent=Y,z=a(),$=o("p"),$.textContent=Z,F=a(),P(b.$$.fragment),R=a(),I=o("p"),this.h()},l(e){const t=se("svelte-u9bgzb",document.head);r=s(t,"META",{name:!0,content:!0}),t.forEach(i),A=l(e),C=s(e,"P",{}),ee(C).forEach(i),M=l(e),L(p.$$.fragment,e),V=l(e),m=s(e,"P",{"data-svelte-h":!0}),x(m)!=="svelte-nk93u7"&&(m.textContent=K),G=l(e),L(u.$$.fragment,e),N=l(e),d=s(e,"P",{"data-svelte-h":!0}),x(d)!=="svelte-15oggd9"&&(d.textContent=U),S=l(e),g=s(e,"OL",{"data-svelte-h":!0}),x(g)!=="svelte-10zvbq4"&&(g.innerHTML=J),H=l(e),L(f.$$.fragment,e),O=l(e),h=s(e,"P",{"data-svelte-h":!0}),x(h)!=="svelte-19cg0xw"&&(h.textContent=Q),D=l(e),c=s(e,"OL",{"data-svelte-h":!0}),x(c)!=="svelte-15f8ovw"&&(c.innerHTML=X),E=l(e),L(v.$$.fragment,e),q=l(e),w=s(e,"P",{"data-svelte-h":!0}),x(w)!=="svelte-ceboa8"&&(w.textContent=Y),z=l(e),$=s(e,"P",{"data-svelte-h":!0}),x($)!=="svelte-1agkd5k"&&($.textContent=Z),F=l(e),L(b.$$.fragment,e),R=l(e),I=s(e,"P",{}),ee(I).forEach(i),this.h()},h(){te(r,"name","hf:doc:metadata"),te(r,"content",ue)},m(e,t){re(document.head,r),n(e,A,t),n(e,C,t),n(e,M,t),T(p,e,t),n(e,V,t),n(e,m,t),n(e,G,t),T(u,e,t),n(e,N,t),n(e,d,t),n(e,S,t),n(e,g,t),n(e,H,t),T(f,e,t),n(e,O,t),n(e,h,t),n(e,D,t),n(e,c,t),n(e,E,t),T(v,e,t),n(e,q,t),n(e,w,t),n(e,z,t),n(e,$,t),n(e,F,t),T(b,e,t),n(e,R,t),n(e,I,t),j=!0},p:ne,i(e){j||(y(p.$$.fragment,e),y(u.$$.fragment,e),y(f.$$.fragment,e),y(v.$$.fragment,e),y(b.$$.fragment,e),j=!0)},o(e){_(p.$$.fragment,e),_(u.$$.fragment,e),_(f.$$.fragment,e),_(v.$$.fragment,e),_(b.$$.fragment,e),j=!1},d(e){e&&(i(A),i(C),i(M),i(V),i(m),i(G),i(N),i(d),i(S),i(g),i(H),i(O),i(h),i(D),i(c),i(E),i(q),i(w),i(z),i($),i(F),i(R),i(I)),i(r),k(p,e),k(u,e),k(f,e),k(v,e),k(b,e)}}}const ue='{"title":"CLIP and Relatives","local":"clip-and-relatives","sections":[{"title":"Pre-CLIP","local":"pre-clip","sections":[],"depth":2},{"title":"Post-CLIP","local":"post-clip","sections":[],"depth":2},{"title":"Conclusion","local":"conclusion","sections":[],"depth":2}],"depth":1}';function de(W){return ae(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ce extends le{constructor(r){super(),oe(this,r,de,me,ie,{})}}export{ce as component};
