import{s as xt,n as Ct,o as Nt}from"../chunks/scheduler.7bc62968.js";import{S as bt,i as _t,g as o,s,r as p,m as Ht,A as kt,h as l,f as n,c as a,j as Mt,u as m,x as r,n as St,k as ie,y as Rt,a as i,v as d,d as f,t as u,w as c}from"../chunks/index.2f8492b0.js";import{H as h,E as qt}from"../chunks/EditOnGithub.2a9ce03a.js";function Pt(Ye){let g,oe,se,le,L,re,y,pe,M,Je=`Videos are made up of a series of images called frames that are played one after another to create motion. Each frame captures spatial information — the objects and scenes in the image. When these frames are shown in sequence, they also provide temporal information — how things change and move over time.
Because of this combination of space and time, videos contain more complex information than single images. To analyze videos effectively, we need models that can understand both the spatial and temporal aspects.`,me,x,de,v,Qe='<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/rnn_video_models/rnn.png" alt="RNN architecture"/>',fe,C,ue,N,Xe=`In video analysis, it’s important to consider both spatial (space) and temporal (time) features together—this is called spatio-temporal modeling. Spatial modeling looks at what’s in each frame, like objects or people, while temporal modeling looks at how these things change from frame to frame.
By combining these two, we can understand the full context of a video. Techniques like combining CNNs and RNNs or using special types of convolutions that capture both space and time are ways researchers achieve this.`,ce,b,he,_,ge,T,Ze='<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/rnn_video_models/lrcn.png" alt="LRCN model architecture"/>',ve,H,et=`<strong>Overview</strong>
Long-term Recurrent Convolutional Networks (LRCN) are models introduced by researchers Donahue et al. in 2015.
They combine CNNs and Long Short-Term Memory networks (LSTMs), a type of RNN, to learn from both the spatial and temporal features in videos.
The CNN processes each frame to extract spatial features, and the LSTM takes these features in sequence to learn how they change over time.`,Te,k,tt="<strong>Key Features</strong>",$e,S,nt="<li><strong>Combining CNN and LSTM:</strong> Spatial features from each frame are fed into the LSTM to model the temporal relationships.</li> <li><strong>Versatile Applications:</strong> LRCNs have been used successfully in tasks like action recognition (identifying actions in videos) and video captioning (generating descriptions of videos).</li>",we,R,it=`<strong>Why It Matters</strong>
LRCN was one of the first models to effectively handle both spatial and temporal aspects of video data. It paved the way for future research by showing that combining CNNs and RNNs can be powerful for video analysis.`,Le,q,ye,$,st='<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/rnn_video_models/convlstm.png" alt="ConvLSTM model architecture"/>',Me,P,at="<strong>Overview</strong>",xe,I,ot="The Convolutional LSTM Network (ConvLSTM) was proposed by Shi et al. in 2015. It modifies the traditional LSTM by incorporating convolutional operations within the LSTM’s structure. This means that instead of processing one-dimensional sequences, ConvLSTM can handle two-dimensional spatial data (like images) over time.",Ce,V,lt="<strong>Key Features</strong>",Ne,E,rt="<li><strong>Spatial Structure Preservation:</strong> By using convolutions, ConvLSTM maintains the spatial layout of the data while processing temporal sequences.</li> <li><strong>Effective for Spatio-Temporal Prediction:</strong> It’s particularly useful for tasks that require predicting how spatial data changes over time, such as weather forecasting or video frame prediction.</li>",be,j,pt=`<strong>Why It Matters</strong>
ConvLSTM introduced a new way to process spatio-temporal data by integrating convolution directly into the LSTM architecture. This has been influential in fields that need to predict future states based on spatial and temporal patterns.`,_e,D,He,U,mt=`<strong>Overview</strong>
In 2015, Srivastava et al. introduced a method for learning video representations without labeled data, known as unsupervised learning. This paper utilizes a multi-layer LSTM model to learn video representations. The model consists of two main components: an Encoder LSTM and a Decoder LSTM. The Encoder maps video sequences of arbitrary length (in the time dimension) to a fixed-size representation. The Decoder then uses this representation to either reconstruct the input video sequence or predict the subsequent video sequence.`,ke,z,dt="<strong>Key Features</strong>",Se,A,ft="<li><strong>Unsupervised Learning:</strong> The model doesn’t require labeled data, making it easier to work with large amounts of video.</li>",Re,B,ut=`<strong>Why It Matters</strong>
This approach showed that it’s possible to learn useful video representations without the need for extensive labeling, which is time-consuming and expensive. It opened up new possibilities for video analysis and generation using unsupervised methods.`,qe,O,Pe,w,ct='<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/rnn_video_models/attention_model.png"/>',Ie,F,ht=`<strong>Overview</strong>
In 2015, Yao et al. introduced attention mechanisms in video models, specifically for video captioning tasks. This approach leverages attention to selectively focus on important temporal and spatial features within the video, allowing the model to generate more accurate and contextually relevant descriptions.`,Ve,W,gt="<strong>Key Features</strong>",Ee,K,vt="<li><strong>Temporal and Spatial Attention:</strong> The attention mechanism dynamically identifies the most relevant frames and regions in a video, ensuring that both local actions (e.g., specific movements) and global context (e.g., overall activity) are considered.</li> <li><strong>Enhanced Representation:</strong> By focusing on significant features, the model combines local and global temporal structures, leading to improved video representations and more precise caption generation.</li>",je,G,Tt=`<strong>Why It Matters</strong>
Incorporating attention mechanisms into video models has transformed how temporal data is processed. This method enhances the model’s capacity to handle the complex interactions in video sequences, making it an essential component in modern neural network architectures for video analysis and generation.`,De,Y,Ue,J,$t="<li><p><strong>Challenges with Long-Term Dependencies</strong></p> <p>RNNs, including LSTMs, can struggle to maintain information over long sequences. This means they might “forget” important details from earlier frames when processing long videos. This limitation can affect the model’s ability to understand the full context of a video.</p></li> <li><p><strong>Computational Complexity and Processing Time</strong></p> <p>Because RNNs process data sequentially—one step at a time—they can be slow, especially with long sequences like videos. This sequential processing makes it difficult to take advantage of parallel computing resources, leading to longer training and inference times.</p></li> <li><p><strong>Emergence of Alternative Models</strong></p> <p>Newer models like Transformers have been developed to address some of the limitations of RNNs. Transformers use attention mechanisms to handle sequences and can process data in parallel, making them faster and more effective at capturing long-term dependencies.</p></li>",ze,Q,Ae,X,wt="RNN-based models have significantly advanced the field of video analysis by providing tools to handle temporal sequences effectively. Models like LRCN, ConvLSTM, and those incorporating attention mechanisms have demonstrated the potential of combining spatial and temporal processing. However, limitations such as difficulty with long sequences, computational inefficiency, and high data requirements highlight the need for continued innovation.",Be,Z,Lt="Future research is likely to focus on overcoming these challenges, possibly by adopting newer architectures like Transformers, improving training efficiency, and enhancing model interpretability. These efforts aim to create models that are both powerful and practical for real-world video applications.",Oe,ee,Fe,te,yt='<li><a href="https://arxiv.org/pdf/1411.4389" rel="nofollow">Long-term Recurrent Convolutional Networks paper</a></li> <li><a href="https://proceedings.neurips.cc/paper_files/paper/2015/file/07563a3fe3bbe7e3ba84431ad9d055af-Paper.pdf" rel="nofollow">Convolutional LSTM Network: A Machine Learning Approach for Precipitation Nowcasting paper</a></li> <li><a href="https://arxiv.org/pdf/1502.04681" rel="nofollow">Unsupervised Learning of Video Representations using LSTMs paper</a></li> <li><a href="https://arxiv.org/pdf/1502.08029" rel="nofollow">Describing Videos by Exploiting Temporal Structure paper</a></li>',We,ne,Ke,ae,Ge;return L=new h({props:{title:"Introduction",local:"introduction",headingTag:"h1"}}),y=new h({props:{title:"Videos as Sequence Data",local:"videos-as-sequence-data",headingTag:"h2"}}),x=new h({props:{title:"The Role and Need for RNNs in Video Processing",local:"the-role-and-need-for-rnns-in-video-processing",headingTag:"h2"}}),C=new h({props:{title:"Understanding Spatio-Temporal Modeling",local:"understanding-spatio-temporal-modeling",headingTag:"h2"}}),b=new h({props:{title:"RNN-Based Video Modeling Architectures",local:"rnn-based-video-modeling-architectures",headingTag:"h1"}}),_=new h({props:{title:"Long-term Recurrent Convolutional Networks(LRCN)",local:"long-term-recurrent-convolutional-networkslrcn",headingTag:"h2"}}),q=new h({props:{title:"Convolutional LSTM Network: A Machine Learning Approach for Precipitation Nowcasting(ConvLSTM)",local:"convolutional-lstm-network-a-machine-learning-approach-for-precipitation-nowcastingconvlstm",headingTag:"h2"}}),D=new h({props:{title:"Unsupervised Learning of Video Representations using LSTMs",local:"unsupervised-learning-of-video-representations-using-lstms",headingTag:"h2"}}),O=new h({props:{title:"Describing Videos by Exploiting Temporal Structure",local:"describing-videos-by-exploiting-temporal-structure",headingTag:"h2"}}),Y=new h({props:{title:"Limitations of RNN-Based Models",local:"limitations-of-rnn-based-models",headingTag:"h1"}}),Q=new h({props:{title:"Conclusion",local:"conclusion",headingTag:"h1"}}),ee=new h({props:{title:"References",local:"references",headingTag:"h3"}}),ne=new qt({props:{source:"https://github.com/huggingface/computer-vision-course/blob/main/chapters/en/unit7/video-processing/rnn-based-video-models.mdx"}}),{c(){g=o("meta"),oe=s(),se=o("p"),le=s(),p(L.$$.fragment),re=s(),p(y.$$.fragment),pe=s(),M=o("p"),M.textContent=Je,me=s(),p(x.$$.fragment),de=s(),v=o("div"),v.innerHTML=Qe,fe=Ht(`
Convolutional Neural Networks (CNNs) are excellent at analyzing spatial features in images. 
However, they aren't designed to handle sequences where temporal relationships matter. This is where Recurrent Neural Networks (RNNs) come in. 
RNNs are specialized for processing sequential data because they have a "memory" that captures information from previous steps. This makes them well-suited for understanding how video frames relate to each other over time.
`),p(C.$$.fragment),ue=s(),N=o("p"),N.textContent=Xe,ce=s(),p(b.$$.fragment),he=s(),p(_.$$.fragment),ge=s(),T=o("div"),T.innerHTML=Ze,ve=s(),H=o("p"),H.innerHTML=et,Te=s(),k=o("p"),k.innerHTML=tt,$e=s(),S=o("ul"),S.innerHTML=nt,we=s(),R=o("p"),R.innerHTML=it,Le=s(),p(q.$$.fragment),ye=s(),$=o("div"),$.innerHTML=st,Me=s(),P=o("p"),P.innerHTML=at,xe=s(),I=o("p"),I.textContent=ot,Ce=s(),V=o("p"),V.innerHTML=lt,Ne=s(),E=o("ul"),E.innerHTML=rt,be=s(),j=o("p"),j.innerHTML=pt,_e=s(),p(D.$$.fragment),He=s(),U=o("p"),U.innerHTML=mt,ke=s(),z=o("p"),z.innerHTML=dt,Se=s(),A=o("ul"),A.innerHTML=ft,Re=s(),B=o("p"),B.innerHTML=ut,qe=s(),p(O.$$.fragment),Pe=s(),w=o("div"),w.innerHTML=ct,Ie=s(),F=o("p"),F.innerHTML=ht,Ve=s(),W=o("p"),W.innerHTML=gt,Ee=s(),K=o("ul"),K.innerHTML=vt,je=s(),G=o("p"),G.innerHTML=Tt,De=s(),p(Y.$$.fragment),Ue=s(),J=o("ul"),J.innerHTML=$t,ze=s(),p(Q.$$.fragment),Ae=s(),X=o("p"),X.textContent=wt,Be=s(),Z=o("p"),Z.textContent=Lt,Oe=s(),p(ee.$$.fragment),Fe=s(),te=o("ol"),te.innerHTML=yt,We=s(),p(ne.$$.fragment),Ke=s(),ae=o("p"),this.h()},l(e){const t=kt("svelte-u9bgzb",document.head);g=l(t,"META",{name:!0,content:!0}),t.forEach(n),oe=a(e),se=l(e,"P",{}),Mt(se).forEach(n),le=a(e),m(L.$$.fragment,e),re=a(e),m(y.$$.fragment,e),pe=a(e),M=l(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-wxbrel"&&(M.textContent=Je),me=a(e),m(x.$$.fragment,e),de=a(e),v=l(e,"DIV",{class:!0,"data-svelte-h":!0}),r(v)!=="svelte-r4beid"&&(v.innerHTML=Qe),fe=St(e,`
Convolutional Neural Networks (CNNs) are excellent at analyzing spatial features in images. 
However, they aren't designed to handle sequences where temporal relationships matter. This is where Recurrent Neural Networks (RNNs) come in. 
RNNs are specialized for processing sequential data because they have a "memory" that captures information from previous steps. This makes them well-suited for understanding how video frames relate to each other over time.
`),m(C.$$.fragment,e),ue=a(e),N=l(e,"P",{"data-svelte-h":!0}),r(N)!=="svelte-1ee8hml"&&(N.textContent=Xe),ce=a(e),m(b.$$.fragment,e),he=a(e),m(_.$$.fragment,e),ge=a(e),T=l(e,"DIV",{class:!0,"data-svelte-h":!0}),r(T)!=="svelte-11gp7be"&&(T.innerHTML=Ze),ve=a(e),H=l(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-1wfsy6s"&&(H.innerHTML=et),Te=a(e),k=l(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-1i4nuav"&&(k.innerHTML=tt),$e=a(e),S=l(e,"UL",{"data-svelte-h":!0}),r(S)!=="svelte-7x3ry"&&(S.innerHTML=nt),we=a(e),R=l(e,"P",{"data-svelte-h":!0}),r(R)!=="svelte-grtv9c"&&(R.innerHTML=it),Le=a(e),m(q.$$.fragment,e),ye=a(e),$=l(e,"DIV",{class:!0,"data-svelte-h":!0}),r($)!=="svelte-1bdprdo"&&($.innerHTML=st),Me=a(e),P=l(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-9pdvmw"&&(P.innerHTML=at),xe=a(e),I=l(e,"P",{"data-svelte-h":!0}),r(I)!=="svelte-shehlv"&&(I.textContent=ot),Ce=a(e),V=l(e,"P",{"data-svelte-h":!0}),r(V)!=="svelte-1i4nuav"&&(V.innerHTML=lt),Ne=a(e),E=l(e,"UL",{"data-svelte-h":!0}),r(E)!=="svelte-178xj27"&&(E.innerHTML=rt),be=a(e),j=l(e,"P",{"data-svelte-h":!0}),r(j)!=="svelte-zxpvg6"&&(j.innerHTML=pt),_e=a(e),m(D.$$.fragment,e),He=a(e),U=l(e,"P",{"data-svelte-h":!0}),r(U)!=="svelte-1mcl1kx"&&(U.innerHTML=mt),ke=a(e),z=l(e,"P",{"data-svelte-h":!0}),r(z)!=="svelte-1i4nuav"&&(z.innerHTML=dt),Se=a(e),A=l(e,"UL",{"data-svelte-h":!0}),r(A)!=="svelte-8bzt2w"&&(A.innerHTML=ft),Re=a(e),B=l(e,"P",{"data-svelte-h":!0}),r(B)!=="svelte-j0vs0g"&&(B.innerHTML=ut),qe=a(e),m(O.$$.fragment,e),Pe=a(e),w=l(e,"DIV",{class:!0,"data-svelte-h":!0}),r(w)!=="svelte-sac4d2"&&(w.innerHTML=ct),Ie=a(e),F=l(e,"P",{"data-svelte-h":!0}),r(F)!=="svelte-mrhjwq"&&(F.innerHTML=ht),Ve=a(e),W=l(e,"P",{"data-svelte-h":!0}),r(W)!=="svelte-1i4nuav"&&(W.innerHTML=gt),Ee=a(e),K=l(e,"UL",{"data-svelte-h":!0}),r(K)!=="svelte-1rlioj5"&&(K.innerHTML=vt),je=a(e),G=l(e,"P",{"data-svelte-h":!0}),r(G)!=="svelte-1h6cy8g"&&(G.innerHTML=Tt),De=a(e),m(Y.$$.fragment,e),Ue=a(e),J=l(e,"UL",{"data-svelte-h":!0}),r(J)!=="svelte-mkpo2k"&&(J.innerHTML=$t),ze=a(e),m(Q.$$.fragment,e),Ae=a(e),X=l(e,"P",{"data-svelte-h":!0}),r(X)!=="svelte-phnkv7"&&(X.textContent=wt),Be=a(e),Z=l(e,"P",{"data-svelte-h":!0}),r(Z)!=="svelte-9wqcc4"&&(Z.textContent=Lt),Oe=a(e),m(ee.$$.fragment,e),Fe=a(e),te=l(e,"OL",{"data-svelte-h":!0}),r(te)!=="svelte-12eejkb"&&(te.innerHTML=yt),We=a(e),m(ne.$$.fragment,e),Ke=a(e),ae=l(e,"P",{}),Mt(ae).forEach(n),this.h()},h(){ie(g,"name","hf:doc:metadata"),ie(g,"content",It),ie(v,"class","flex justify-center"),ie(T,"class","flex justify-center"),ie($,"class","flex justify-center"),ie(w,"class","flex justify-center")},m(e,t){Rt(document.head,g),i(e,oe,t),i(e,se,t),i(e,le,t),d(L,e,t),i(e,re,t),d(y,e,t),i(e,pe,t),i(e,M,t),i(e,me,t),d(x,e,t),i(e,de,t),i(e,v,t),i(e,fe,t),d(C,e,t),i(e,ue,t),i(e,N,t),i(e,ce,t),d(b,e,t),i(e,he,t),d(_,e,t),i(e,ge,t),i(e,T,t),i(e,ve,t),i(e,H,t),i(e,Te,t),i(e,k,t),i(e,$e,t),i(e,S,t),i(e,we,t),i(e,R,t),i(e,Le,t),d(q,e,t),i(e,ye,t),i(e,$,t),i(e,Me,t),i(e,P,t),i(e,xe,t),i(e,I,t),i(e,Ce,t),i(e,V,t),i(e,Ne,t),i(e,E,t),i(e,be,t),i(e,j,t),i(e,_e,t),d(D,e,t),i(e,He,t),i(e,U,t),i(e,ke,t),i(e,z,t),i(e,Se,t),i(e,A,t),i(e,Re,t),i(e,B,t),i(e,qe,t),d(O,e,t),i(e,Pe,t),i(e,w,t),i(e,Ie,t),i(e,F,t),i(e,Ve,t),i(e,W,t),i(e,Ee,t),i(e,K,t),i(e,je,t),i(e,G,t),i(e,De,t),d(Y,e,t),i(e,Ue,t),i(e,J,t),i(e,ze,t),d(Q,e,t),i(e,Ae,t),i(e,X,t),i(e,Be,t),i(e,Z,t),i(e,Oe,t),d(ee,e,t),i(e,Fe,t),i(e,te,t),i(e,We,t),d(ne,e,t),i(e,Ke,t),i(e,ae,t),Ge=!0},p:Ct,i(e){Ge||(f(L.$$.fragment,e),f(y.$$.fragment,e),f(x.$$.fragment,e),f(C.$$.fragment,e),f(b.$$.fragment,e),f(_.$$.fragment,e),f(q.$$.fragment,e),f(D.$$.fragment,e),f(O.$$.fragment,e),f(Y.$$.fragment,e),f(Q.$$.fragment,e),f(ee.$$.fragment,e),f(ne.$$.fragment,e),Ge=!0)},o(e){u(L.$$.fragment,e),u(y.$$.fragment,e),u(x.$$.fragment,e),u(C.$$.fragment,e),u(b.$$.fragment,e),u(_.$$.fragment,e),u(q.$$.fragment,e),u(D.$$.fragment,e),u(O.$$.fragment,e),u(Y.$$.fragment,e),u(Q.$$.fragment,e),u(ee.$$.fragment,e),u(ne.$$.fragment,e),Ge=!1},d(e){e&&(n(oe),n(se),n(le),n(re),n(pe),n(M),n(me),n(de),n(v),n(fe),n(ue),n(N),n(ce),n(he),n(ge),n(T),n(ve),n(H),n(Te),n(k),n($e),n(S),n(we),n(R),n(Le),n(ye),n($),n(Me),n(P),n(xe),n(I),n(Ce),n(V),n(Ne),n(E),n(be),n(j),n(_e),n(He),n(U),n(ke),n(z),n(Se),n(A),n(Re),n(B),n(qe),n(Pe),n(w),n(Ie),n(F),n(Ve),n(W),n(Ee),n(K),n(je),n(G),n(De),n(Ue),n(J),n(ze),n(Ae),n(X),n(Be),n(Z),n(Oe),n(Fe),n(te),n(We),n(Ke),n(ae)),n(g),c(L,e),c(y,e),c(x,e),c(C,e),c(b,e),c(_,e),c(q,e),c(D,e),c(O,e),c(Y,e),c(Q,e),c(ee,e),c(ne,e)}}}const It='{"title":"Introduction","local":"introduction","sections":[{"title":"Videos as Sequence Data","local":"videos-as-sequence-data","sections":[],"depth":2},{"title":"The Role and Need for RNNs in Video Processing","local":"the-role-and-need-for-rnns-in-video-processing","sections":[],"depth":2},{"title":"Understanding Spatio-Temporal Modeling","local":"understanding-spatio-temporal-modeling","sections":[],"depth":2}],"depth":1}';function Vt(Ye){return Nt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ut extends bt{constructor(g){super(),_t(this,g,Vt,Pt,xt,{})}}export{Ut as component};
